<?php
// This file is part of the Studyplan plugin for Moodle
//
// Moodle is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Moodle is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Moodle.  If not, see <https://www.gnu.org/licenses/>.
/**
 *
 * @package    local_treestudyplan
 * @copyright  2023 P.M. Kuipers
 * @license    https://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */

namespace local_treestudyplan;


class success {
    private $success;
    private $msg;

    public static function success($msg="") {
        return new self(true, $msg);
    }

    public static function fail($msg="") {
        return new self(false, $msg);
    }

    public function __construct($success, $msg) {
        $this->success = ($success)?true:false;
        $this->msg = $msg;
    }

    public static function structure() {
        return new \external_single_structure([
            "success" => new \external_value(PARAM_BOOL, 'operation completed succesfully'),
            "msg" => new \external_value(PARAM_TEXT, 'message'),
        ]);
    }

    public function model() {
        return ["success" => $this->success, "msg"=> $this->msg];
    }

    public function successful() {
        return $this->success;
    }

    public function msg() {
        return $this->msg;
    }



}